/***************************************************************************
*   Copyright (C) 2005 by Achal Dhir                                      *
*   achaldhir@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

// dualserver.cpp

#include <sys/types.h>
#include <limits.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <limits.h>
#include <memory.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <string.h>
#include "dualserver.h"

//Function Prototypes
void glocal(data2*);
WORD pQu(char*, char*);
WORD fQu(char *name, dns_packet *mess, char *raw);
DWORD fLong(char*);
WORD fShort(char*);
BYTE pLong(char*, DWORD);
BYTE pShort(char*, WORD);
WORD gdmess(data1*, data2*);
DWORD sdmess(data1*, data2*);
void gvdata(data1*, data3*);
BYTE *pvdata(BYTE*, data1*, data3*);
void indata(data2*);
BYTE *addOp(data1*, data2*);
char* IP2String(DWORD ip);
time_t getExpiry(dns_packet *dnsp);
char* getResult(dns_packet *mess);
DWORD resad(data1 *req, data2 *cfig);
DWORD chad(DWORD ip, data1 *req, data2 *cfig);
DWORD alad(data1 *req, data2 *cfig);
WORD gdnmess(data5*, data2*);
WORD scanloc(data5*, data2*);
void getClInfo(data5 *req);
int sdnmess(data5*, data2*);
WORD fdnmess(data5*, data2*);
WORD scancat(data5*, data2*);
WORD frdnmess(data5*, data2*);
void getdnserv(data2 *cfig);
char* cleanstr(char*, BOOL);
BOOL getSection(char *sectionName, char *buffer, int sizeoftemp, char *fileName);
int getIndex(data2 *cfig, DWORD ip);
DWORD getNetwork(DWORD ip);
void loadOptions(data2 *cfig, BYTE *buff, WORD buffsize, char *iniStr, char *section, int clientIndex);
char *getHexValue(BYTE *target, char *source);
void addEntry(data2 *cfig, DWORD *array, DWORD entry);
DWORD my_inet_addr(char*);
void runprog();

//Global veriables
char tempbuff[256];
char iniFile[] = "/etc/dualserver.ini";
char leaFile[] = "/etc/dualserver.state";
BOOL dhcpService = true;
BOOL dnsService = true;
BOOL verbatim;
timeval tv;
fd_set readfds;
fd_set writefds;
BYTE op_index[] = {2, 4, 5, 7, 8, 9, 10, 11, 16, 19, 20, 21, 21, 95, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 44, 45, 46, 47, 48, 49, 58, 59, 62, 63, 64, 65, 66, 68, 69, 70, 71, 72, 73, 74, 75, 76, 83, 85, 86, 87, 116, 117, 118, 119, 128, 129, 130, 131, 135, 176, 0, 0, 67, 13, 17, 18, 0, 12};
BYTE op_size[] = {4, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 255, 1, 4, 2, 2, 1, 0, 1, 1, 1, 0, 0, 0, 1, 4, 1, 1, 4, 1, 255, 0, 0, 0, 0, 1, 255, 0, 0, 4, 4, 255, 0, 255, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 255, 255, 1, 2, 0, 255, 0, 0, 255, 0, 0, 255, 1, 0, 255, 2, 255, 255, 255, 255};
char op_name[][40] =
    {
        "Time_Offset",
        "Time_Server",
        "Name_Server",
        "Log_Server",
        "Cookie_Server",
        "LPR_Server",
        "Impress_Server",
        "RLP_Server",
        "Swap_Server",
        "Forward_On/Off",
        "SrcRte_On/Off",
        "Policy_Filter_IP",
        "Policy_Filter_Mask",
        "LDAP_URL",
        "Default_IP_TTL",
        "MTU_Timeout",
        "MTU_Plateau",
        "MTU_Interface",
        "MTU_Subnet",
        "Broadcast_Address",
        "Mask_Discovery",
        "Mask_Supplier",
        "Router_Discovery",
        "Router_Request",
        "Static_Route_IP",
        "Static_Route_Mask",
        "Trailers",
        "ARP_Timeout",
        "Ethernet_Encp",
        "Default_TCP_TTL",
        "Keepalive_Time",
        "Keepalive_Data",
        "NIS_Domain",
        "NIS_Servers",
        "NTP_Servers",
        "NETBIOS_Name_Srv",
        "NETBIOS_Dist_Srv",
        "NETBIOS_Node_Type",
        "NETBIOS_Scope",
        "X_Window_Font",
        "X_Window_Manager",
        "Renewal_Time",
        "Rebinding_Time",
        "Netware/IP_Domain",
        "Netware/IP_Option",
        "NIS+_Domain_Name",
        "NIS+_Server_Addr",
        "TFTP_Server_Name",
        "Home_Agent_Addrs",
        "SMTP_Server",
        "POP3_Server",
        "NNTP_Server",
        "WWW_Server",
        "Finger_Server",
        "IRC_Server",
        "StreetTalk_Server",
        "STDA_Server",
        "iSNS",
        "NDS_Servers",
        "NDS_Tree_Name",
        "NDS_Context",
        "Auto_Configure",
        "Name_Service_Search",
        "Subnet_Selection",
        "DNS_Domain_Search",
        "TFTP_Server",
        "Call_Server",
        "Discrimination_String",
        "RemoteStatisticsServer",
        "Phone_Http_Proxy",
        "IP_Phone",
        "Send_Only_Requested_Options",
        "Next_Server",
        "Boot_File",
        "Boot_File_Size",
        "Root_Path",
        "Extension_Path",
        "Hardware_Addr",
        "Hostname"
    };

int main(int argc, char **argv)
{
	verbatim = (argc > 1 && !strcasecmp(argv[1], "-v"));
	if (verbatim)
	{
		if (getuid())
		{
			printf("Error: Only root should run this program\n");
			exit(1);
		}
		data2 cfig;
		data1 dhcpr;
		data5 dnsr;
		indata(&cfig);

		if (dnsService && dhcpService)
			printf("Starting DNS Service..\nStarting DHCP Service..\n\nRemote DNS Servers: ");
		else if (dnsService)
			printf("Starting DNS Service..\n\nRemote DNS Servers: ");
		else
			printf("Starting DHCP Service..\n\nLocal DNS Servers: ");
		for (int i = 0; cfig.dns[i];i++)
			printf("%s ", IP2String(cfig.dns[i]));
		if (dhcpService)
		{
			printf("\nDHCP Range: %s", IP2String(htonl(cfig.rangeStart)));
			printf(" - %s", IP2String(htonl(cfig.rangeEnd)));
		}
		printf("\nDefault Gateways: ");
		for (int i = 0; cfig.routers[i];i++)
			printf("%s ", IP2String(cfig.routers[i]));

		printf("\nServer Name: %s", cfig.servername);
		printf("\nLocal Zone: %s", cfig.domainname);
		printf("\nSubnet Mast: %s", IP2String(cfig.subnetmask));
		printf("\nLocal Interfaces: ");
		if (cfig.servers[0])
			for (int i = 0; cfig.servers[i];i++)
				printf("%s ", IP2String(cfig.servers[i]));
		else
			printf("%s ", "none found");

		if (cfig.lease == ULONG_MAX)
			printf("\nMax Lease Time: Infinity");
		else
			printf("\nMax Lease Time: %u (sec)", cfig.lease);

		printf("\nListening On: %s", IP2String(cfig.serverip));
		printf("\n\nAccepting requests..\n");

		while (1)
		{
			tv.tv_sec = 10;
			tv.tv_usec = 0;

			FD_ZERO(&readfds);
			//FD_ZERO(&writefds);

			FD_SET(cfig.socket[0], &readfds);
			FD_SET(cfig.socket[1], &readfds);
			FD_SET(cfig.socket[2], &readfds);

			select(INT_MAX, &readfds, NULL, NULL, &tv);

			if (FD_ISSET(cfig.socket[0], &readfds))
			{
				if (gdmess(&dhcpr, &cfig))
				{
					sdmess(&dhcpr, &cfig);
					if (dhcpr.resp_type == DHCP_MESS_ACK)
						printf("Host %s alotted %s for %u seconds\n", dhcpr.hostname, IP2String(dhcpr.dhcpp.bp_yiaddr), dhcpr.lease);
				}
			}

			if (FD_ISSET(cfig.socket[2], &readfds))
			{
				if (frdnmess(&dnsr, &cfig))
				{
					sdnmess(&dnsr, &cfig);
					if (getResult(&dnsr.dnsp))
						printf("%s resolved from Forwarding server as %s\n", dnsr.query, tempbuff);
				}
			}

			if (FD_ISSET(cfig.socket[1], &readfds))
			{
				if (gdnmess(&dnsr, &cfig))
				{
					if (scanloc(&dnsr, &cfig))
					{
						if (htons(dnsr.dnsp.header.ancount))
							printf("%s resolved Locally to %s\n", dnsr.query, getResult(&dnsr.dnsp));
						sdnmess(&dnsr, &cfig);
					}
					else if (scancat(&dnsr, &cfig))
					{
						if (getResult(&dnsr.dnsp))
							printf("%s resolved from cache as %s\n", dnsr.query, tempbuff);
						sdnmess(&dnsr, &cfig);
					}
					else if (!fdnmess(&dnsr, &cfig))
					{
						printf("Failed to forward query %s\n", dnsr.query);
						sdnmess(&dnsr, &cfig);
					}
				}
			}
		}
	}
	else
	{
		if (getuid())
		{
			syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Only root should run this program");
			exit(1);
		}

		/* Our process ID and Session ID */
		pid_t pid, sid;

		/* Fork off the parent process */
		pid = fork();
		if (pid < 0)
		{
			exit(EXIT_FAILURE);
		}
		/* If we got a good PID, then
		we can exit the parent process. */
		if (pid > 0)
		{
			exit(EXIT_SUCCESS);
		}

		/* Change the file mode mask */
		umask(0);

		/* Open any logs here */

		/* Create a new SID for the child process */
		sid = setsid();
		if (sid < 0)
		{
			/* Log the failure */
			exit(EXIT_FAILURE);
		}

		/* Change the current working directory */
		if ((chdir("/")) < 0)
		{
			/* Log the failure */
			exit(EXIT_FAILURE);
		}

		/* Close out the standard file descriptors */
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);

		/* Daemon-specific initialization goes here */
		data2 cfig;
		data1 dhcpr;
		data5 dnsr;
		indata(&cfig);

		/* The Big Loop */
		while (1)
		{
			tv.tv_sec = 10;
			tv.tv_usec = 0;

			FD_ZERO(&readfds);
			//FD_ZERO(&writefds);

			FD_SET(cfig.socket[0], &readfds);
			FD_SET(cfig.socket[1], &readfds);
			FD_SET(cfig.socket[2], &readfds);

			select(INT_MAX, &readfds, NULL, NULL, &tv);

			if (FD_ISSET(cfig.socket[0], &readfds))
			{
				if (gdmess(&dhcpr, &cfig))
					sdmess(&dhcpr, &cfig);
			}

			if (FD_ISSET(cfig.socket[2], &readfds))
			{
				if (frdnmess(&dnsr, &cfig))
					sdnmess(&dnsr, &cfig);
			}

			if (FD_ISSET(cfig.socket[1], &readfds))
			{
				if (gdnmess(&dnsr, &cfig))
				{
					if (scanloc(&dnsr, &cfig))
						sdnmess(&dnsr, &cfig);
					else if (scancat(&dnsr, &cfig))
						sdnmess(&dnsr, &cfig);
					else if (!fdnmess(&dnsr, &cfig))
						sdnmess(&dnsr, &cfig);
				}
			}
		}
	}

	exit(EXIT_SUCCESS);
}

WORD fQu(char *name, dns_packet *mess, char *raw)
{
	BYTE *xname = (BYTE*)name;
	BYTE *xraw = (BYTE*)raw;
	WORD retvalue = 0;
	BOOL goneout = 0;
	while (true)
	{
		WORD size = (BYTE) * xraw;
		xraw++;
		if (size <= 63)
		{
			if (!goneout)
				retvalue += (size + 1);
			memcpy(xname, xraw, size);
			xname += size;
			xraw += size;
			if (!*xraw)
				break;
			*xname = '.';
			xname++;
		}
		else
		{
			if (!goneout)
				retvalue += 2;
			goneout = 1;
			size %= 128;
			size %= 64;
			size *= 256;
			size += *xraw;
			if (size > sizeof(dns_packet))
				break;
			xraw = (BYTE*)mess + size;
		}
	}
	*xname = 0;
	if (!goneout)
		retvalue++;
	return retvalue;
}

WORD pQu(char *raw, char *name)
{
	WORD fullsize = 1;
	while (true)
	{
		char *i = strchr(name, 46);
		if (i != NULL)
		{
			int size = (DWORD)i - (DWORD)name;
			*raw = size;
			raw++;
			memcpy(raw, name, size);
			raw += size;
			name += size + 1;
			fullsize += size + 1;
		}
		else
		{
			int size = strlen(name);
			*raw = size;
			raw++;
			strcpy(raw, name);
			fullsize += size + 1;
			break;
		}
	}
	return fullsize;
}

WORD genMess(data5 *req, data2 *cfig)
{
	//printf("\n%i", req->rtype);

	if (!req->rtype)
	{
		req->dnsp.header.ancount = 0;
		req->dnsp.header.rcode = 3;
		req->dnsp.header.ra = 0;
	}

	if (cfig->servers[0])
	{
		req->dnsp.header.nscount = htons(1);
		req->dnsp.header.adcount = htons(1);
	}
	else
	{
		req->dnsp.header.nscount = 0;
		req->dnsp.header.adcount = 0;
	}

	req->dnsp.header.qr = 1;
	req->dnsp.header.aa = 1;

	char *raw = req->dnsp.data;

	for (int i = 1; i <= ntohs(req->dnsp.header.qdcount); i++)
	{
		if ((unsigned char)*raw > 63)
			raw += 2;
		else
			raw += strlen(raw) + 1;
		raw += 4;
	}

	switch (req->rtype)
	{
	case 1:
		req->dnsp.header.ancount = htons(1);
		raw += pQu(raw, req->query);
		raw += pShort(raw, DNS_TYPE_A);
		raw += pShort(raw, DNS_CLASS_IN);
		raw += pLong(raw, req->lease);
		raw += pShort(raw, 4);
		memcpy(raw, req->response, 4);
		raw += 4;
		break;
	case 2:
		req->dnsp.header.ancount = htons(1);
		raw += pQu(raw, req->query);
		raw += pShort(raw, DNS_TYPE_PTR);
		raw += pShort(raw, DNS_CLASS_IN);
		raw += pLong(raw, req->lease);
		raw += pShort(raw, strlen(req->response) + 2);
		raw += pQu(raw, req->response);
		break;
	case 3:
		req->dnsp.header.ancount = htons(cfig->mxCount);
		for (int m = 0; m < cfig->mxCount; m++)
		{
			raw += pQu(raw, req->query);
			raw += pShort(raw, DNS_TYPE_MX);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, req->lease);
			raw += pShort(raw, strlen(cfig->mxServers[m].hostname) + 4);
			raw += pShort(raw, cfig->mxServers[m].pref);
			raw += pQu(raw, cfig->mxServers[m].hostname);
		}
		break;
	case 4:
	case 5:
		req->dnsp.header.ancount = htons(1);
		raw += pQu(raw, req->query);
		raw += pShort(raw, DNS_TYPE_CNAME);
		raw += pShort(raw, DNS_CLASS_IN);
		raw += pLong(raw, req->lease);
		if (!strchr(req->cname, '.') && req->rtype == 4)
		{
			strcat(req->cname, ".");
			strcat(req->cname, cfig->domainname);
		}
		raw += pShort(raw, strlen(req->cname) + 2);
		raw += pQu(raw, req->cname);

		if (strlen(req->response))
		{
			req->dnsp.header.ancount = htons(2);
			raw += pQu(raw, req->cname);
			raw += pShort(raw, DNS_TYPE_A);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, req->lease);
			raw += pShort(raw, 4);
			memcpy(raw, req->response, 4);
			raw += 4;
		}
	}

	if (cfig->servers[0])
	{
		if (req->qtype == DNS_TYPE_PTR)
		{
			if (cfig->serverip)
				IP2String(htonl(cfig->serverip));
			else
				IP2String(htonl(cfig->servers[0]));
			strcat(tempbuff, ".in-addr.arpa");
			char *x = strchr(tempbuff, '.');
			x++;
			raw += pQu(raw, x);
		}
		else
			raw += pQu(raw, cfig->domainname);

		raw += pShort(raw, DNS_TYPE_NS);
		raw += pShort(raw, DNS_CLASS_IN);

		if (cfig->lease >= ULONG_MAX / 24)
			raw += pLong(raw, ULONG_MAX);
		else
			raw += pLong(raw, 24 * cfig->lease);

		raw += pShort(raw, strlen(cfig->servername_fqn) + 2);
		raw += pQu(raw, cfig->servername_fqn);

		raw += pQu(raw, cfig->servername_fqn);
		raw += pShort(raw, DNS_TYPE_A);
		raw += pShort(raw, DNS_CLASS_IN);

		if (cfig->lease >= ULONG_MAX / 24)
			raw += pLong(raw, ULONG_MAX);
		else
			raw += pLong(raw, 24 * cfig->lease);

		raw += pShort(raw, sizeof(DWORD));

		if (cfig->serverip)
			memcpy(raw, &cfig->serverip, sizeof(DWORD));
		else
			memcpy(raw, &cfig->servers[0], sizeof(DWORD));

		raw += sizeof(DWORD);
	}
	req->bytes = ((DWORD)raw - (DWORD)req->raw);
	return req->bytes;
}

WORD fShort(char *raw)
{
	return ntohs(*(WORD*)raw);
}

DWORD fLong(char *raw)
{
	return ntohl(*(DWORD*)raw);
}

BYTE pShort(char *raw, WORD data)
{
	*(WORD*)raw = htons(data);
	return sizeof(WORD);
}

BYTE pLong(char *raw, DWORD data)
{
	*(DWORD*)raw = htonl(data);
	return sizeof(DWORD);
}

WORD gdnmess(data5 *req, data2 *cfig)
{
	errno = 0;
	memset(req, 0, sizeof(data5));
	socklen_t nLen = sizeof(req->sockAddr);
	req->bytes = recvfrom(cfig->socket[1],
	                      req->raw,
	                      sizeof(dns_packet),
	                      0,
	                      (LPSOCKADDR) & req->sockAddr,
	                      &nLen);
	if (errno || req->bytes < 0 || getIndex(cfig, req->sockAddr.sin_addr.s_addr) < 0)
		req->bytes = 0;

	return req->bytes;
}

WORD scanloc(data5 *req, data2 *cfig)
{
	req->lease = cfig->lease;

	if (!cfig->dns[0])
		getdnserv(cfig);

	if (ntohs(req->dnsp.header.qdcount) == 1 && ntohs(req->dnsp.header.opcode) == 0)
	{
		char *raw = req->dnsp.data;
		fQu(req->query, &req->dnsp, raw);

		if (!req->query[0])
			return 0;

		raw += strlen(raw) + 1;
		strcpy(req->cname, req->query);

		req->qtype = fShort(raw);
		raw += 2;
		req->qclass = fShort(raw);
		if (req->qclass == DNS_CLASS_IN && req->qtype == DNS_TYPE_A)
		{
			if (!strcasecmp(req->query, cfig->domainname) && cfig->webServer)
			{
				strcpy(req->cname, cfig->webServer);
				req->rtype = 4;
			}
			else
			{
				req->domainname = strchr(req->cname, '.');
				if (req->domainname)
				{
					if (strcasecmp((req->domainname + 1), cfig->domainname))
						return 0;
					*req->domainname = 0;
					req->domainname++;
				}
			}

			for (int n = 0; n < 5; n++)
			{
				if (!strcasecmp(req->cname, cfig->servername))
				{
					if (cfig->serverip)
						req->responselong = cfig->serverip;
					else
						req->responselong = cfig->servers[0];
				}
				else if (!strcasecmp(req->cname, "localhost"))
				{
					req->responselong = inet_addr("127.0.0.1");
					if (req->domainname)
						req->rtype = 5;
					else
						req->rtype = 1;
				}
				else
				{
					int j = cfig->rangeEnd - cfig->rangeStart;
					DWORD k = time(NULL);
					int i = 0;
					for (; i <= j; i++)
					{
						if (!strcasecmp(req->cname, cfig->clients[i].hostname) && (cfig->clients[i].static_host || cfig->clients[i].server || cfig->clients[i].expiry > k))
						{
							req->responselong = htonl(cfig->rangeStart + i);
							if (!cfig->clients[i].static_host && !cfig->clients[i].server)
								req->lease = cfig->clients[i].expiry - k;
							break;
						}
					}
				}

				if (req->responselong)
				{
					if (!req->rtype)
					{
						if (req->domainname)
							req->rtype = 1;
						else
							req->rtype = 4;
					}
					return genMess(req, cfig);
				}

				if (!strcasecmp(req->cname, "www") && cfig->webServer)
				{
					strcpy(req->cname, cfig->webServer);
					req->rtype = 4;
				}
				else
				{
					int m;
					for (m = 0; cfig->cnames[m].alias[0] && m < DNS_MAX_ALIAS; m++)
					{
						if (!strcasecmp(req->cname, cfig->cnames[m].alias))
						{
							strcpy(req->cname, cfig->cnames[m].cname);
							req->rtype = 4;
							break;
						}
					}
					if (!cfig->cnames[m].alias[0])
						 n == 3;
				}

				char *dp = strchr(req->cname, '.');
				if (dp)
				{
					if (strcasecmp(dp+1, cfig->domainname))
					{
						char *px = req->dnsp.data;
						px += pQu(px, req->cname);
						px += pShort(px, DNS_TYPE_A);
						px += pShort(px, DNS_CLASS_IN);
						req->bytes = (DWORD)px - (DWORD)&req->dnsp;
						return 0;
					}
					*dp = 0;
				}
			}
			return genMess(req, cfig);
		}
		else if (req->qclass == DNS_CLASS_IN && req->qtype == DNS_TYPE_MX && !strcasecmp(req->cname, cfig->domainname))
		{
			req->rtype = 3;
			return genMess(req, cfig);
		}
		else if (req->qclass == DNS_CLASS_IN && req->qtype == DNS_TYPE_PTR)
		{
			//strlwr(req->cname);
			strcpy(tempbuff, req->cname);
			char *dp = strstr(tempbuff, ".in-addr.arpa");
			if (dp != NULL)
				*dp = 0;
			DWORD arpa_addr = htonl(inet_addr(tempbuff));
			DWORD k = time(NULL);
			if (!arpa_addr)
			{
				return 0;
			}
			else if (arpa_addr == cfig->servers[0] || arpa_addr == cfig->servers[1] || arpa_addr == cfig->servers[2] || arpa_addr == cfig->servers[3] || arpa_addr == cfig->servers[4])
			{
				strcpy(req->response, cfig->servername_fqn);
				req->rtype = 2;
			}
			else if (arpa_addr == inet_addr("127.0.0.1"))
			{
				strcpy(req->response, "localhost");
				req->rtype = 2;
			}
			else
			{
				int i = getIndex(cfig, arpa_addr);

				if (i < 0)
					return 0;

				if (cfig->clients[i].hostname[0] && (cfig->clients[i].expiry > k || cfig->clients[i].static_host || cfig->clients[i].server))
				{
					sprintf(req->response, "%s.%s", cfig->clients[i].hostname, cfig->domainname);
					if (!cfig->clients[i].static_host && !cfig->clients[i].server)
						req->lease = cfig->clients[i].expiry - time(NULL);
					req->rtype = 2;
				}
			}
			return genMess(req, cfig);
		}
	}
	return 0;
}

WORD scancat(data5 *req, data2 *cfig)
{
	if (!req->query[0])
		return 0;

	WORD xid = req->dnsp.header.xid;
	for (int i = 0; i < DNS_CACHE_MAX; i++)
	{
		if (!strcasecmp(req->query, cfig->cache[i].query))
			if (req->qtype == cfig->cache[i].qtype && cfig->cache[i].expiry >= time(NULL))
			{
				memcpy(req->raw, &cfig->cache[i].dnsp, cfig->cache[i].bytes);
				req->bytes = cfig->cache[i].bytes;
				req->dnsp.header.xid = xid;
				return req->bytes;
			}
	}
	return 0;
}

int sdnmess(data5 *req, data2 *cfig)
{
	errno = 0;
	req->bytes = sendto(cfig->socket[1],
	                    req->raw,
	                    req->bytes,
	                    0,
	                    (LPSOCKADDR) & req->sockAddr,
	                    sizeof(req->sockAddr));
	if (errno || req->bytes <= 0)
		return 0;
	else
		return req->bytes;
}


WORD fdnmess(data5 *req, data2 *cfig)
{
	if (!req->dnsp.header.rd)
		return 0;

	if (!cfig->dns[0])
		getdnserv(cfig);

	int nRet = -1;
	int i;
	for (i = 0; i < 5; i++)
	{
		if (req->sockAddr.sin_addr.s_addr == cfig->dns[0])
		{
			continue;
		}

		if (!cfig->dns[0])
			break;

		cfig->sockAddr[2].sin_family = AF_INET;
		cfig->sockAddr[2].sin_addr.s_addr = cfig->dns[0];
		cfig->sockAddr[2].sin_port = htons(IPPORT_DNS);

		errno = 0;

		nRet = sendto(cfig->socket[2],
		              req->raw,
		              req->bytes,
		              0,
		              (LPSOCKADDR) & cfig->sockAddr[2],
		              sizeof(cfig->sockAddr[2]));

		if (!errno && nRet > 0)
			break;
		else
		{
			for (int j = 1; j < 5; j++)
				cfig->dns[j - 1] = cfig->dns[j];
			cfig->dns[4] = 0;
		}
	}

	//put in queue
	if (!errno && nRet > 0)
	{
		BOOL found = false;
		for (int i = cfig->queries_awaited; i && !found; i--)
			if (req->dnsp.header.xid == cfig->queue[i - 1].xid)
				found = true;

		if (!found)
		{
			if (cfig->queries_awaited == DNS_FORWARDS_MAX)
			{
				int i;
				for (i = 0; i < DNS_FORWARDS_MAX - 1; i++)
					memcpy(&cfig->queue[i], &cfig->queue[i + 1], sizeof(data6));
				cfig->queries_awaited--;
			}
			cfig->queue[cfig->queries_awaited].xid = req->dnsp.header.xid;
			cfig->queue[cfig->queries_awaited].qtype = req->qtype;
			memcpy(&cfig->queue[cfig->queries_awaited].source, &req->sockAddr, sizeof(SOCKADDR_IN));
			strcpy(cfig->queue[cfig->queries_awaited].cname, req->cname);
			strcpy(cfig->queue[cfig->queries_awaited].query, req->query);
			cfig->queries_awaited++;
		}
		return (nRet);
	}
	else
	{
		req->dnsp.header.ancount = 0;
		req->dnsp.header.rcode = 3;
		req->dnsp.header.ra = 0;
		req->dnsp.header.qr = 1;
		req->dnsp.header.aa = 0;
		char *dp = req->dnsp.data;
		dp += pQu(dp, req->query);
		dp += pShort(dp, DNS_TYPE_A);
		dp += pShort(dp, DNS_CLASS_IN);
		req->bytes = (DWORD)dp - (DWORD) & req->dnsp;
		return 0;
	}
}

WORD frdnmess(data5 *req, data2 *cfig)
{
	errno = 0;
	socklen_t nRet = sizeof(cfig->sockAddr[2]);
	req->bytes = recvfrom(cfig->socket[2],
	                      req->raw,
	                      sizeof(dns_packet),
	                      0,
	                      (LPSOCKADDR) & cfig->sockAddr[2],
	                      &nRet);

	if (errno)
		return 0;

	if (!cfig->queries_awaited)
		return 0;

	BOOL found = false;
	for (int queueIndex = 0; queueIndex < cfig->queries_awaited; queueIndex++)
	{
		if (!found)
		{
			if (cfig->queue[queueIndex].xid == req->dnsp.header.xid)
			{
				found = true;
				memcpy(&req->sockAddr, &cfig->queue[queueIndex].source, sizeof(SOCKADDR_IN));
				cfig->queue[queueIndex].xid = 0;
				strcpy(req->cname, cfig->queue[queueIndex].cname);
				strcpy(req->query, cfig->queue[queueIndex].query);
				req->qtype = cfig->queue[queueIndex].qtype;
				cfig->queries_awaited--;

				if (strcasecmp(req->cname, req->query))
				{
					//manuplate the response
					dns_packet resp;
					memcpy(&resp, &req->dnsp, sizeof(dns_packet));
					req->dnsp.header.qdcount = htons(1);
					req->dnsp.header.ancount = htons(1);
					req->dnsp.header.nscount = htons(0);
					req->dnsp.header.adcount = htons(0);

					char *raw = req->dnsp.data;
					raw += pQu(raw, req->query);
					raw += pShort(raw, DNS_TYPE_A);
					raw += pShort(raw, DNS_CLASS_IN);

					raw += pQu(raw, req->query);
					raw += pShort(raw, DNS_TYPE_CNAME);
					raw += pShort(raw, DNS_CLASS_IN);
					raw += pLong(raw, req->lease);
					raw += pShort(raw, strlen(req->cname) + 2);
					raw += pQu(raw, req->cname);

					char *dp = resp.data;
					for (int i = 1; i <= ntohs(resp.header.qdcount); i++)
					{
						if ((BYTE)*dp > 63)
							dp += 2;
						else
							dp += strlen(dp) + 1;
						dp += 4;
					}

					char tempdata[256];
					for (int i = 1; i <= ntohs(resp.header.ancount); i++)
					{
						char *xraw = tempdata;
						//printf("Qureysize=%i\n", fQu(tempbuff, &resp, dp));
						dp += fQu(tempbuff, &resp, dp);
						//printf(tempbuff);
						xraw += pQu(xraw, tempbuff);
						//dp += 4;
						memcpy(xraw, dp, 8);
						xraw += 8;
						int type = fShort(dp);
						dp += 2; //type
						dp += 2; //class
						dp += 4; //ttl
						WORD dlen = fShort(dp);
						dp += 2; //datalength

						switch (type)
						{
						case DNS_TYPE_A:
							//printf("in a,dlen=%u\n", dlen);
							xraw += pShort(xraw, dlen);
							memcpy(xraw, dp, dlen);
							xraw += dlen;
							//printf("out a\n");
							break;
							//case DNS_TYPE_PTR:
						case DNS_TYPE_CNAME:
							{
								//printf("in cname\n");
								fQu(tempbuff, &resp, dp);
								int dl = pQu(xraw + 2, tempbuff);
								xraw += pShort(xraw, dl);
								xraw += dl;
								//printf("out cname\n");

							}
							break;
						case DNS_TYPE_MX:
							{
								fQu(tempbuff, &resp, dp + 4);
								int dl = pQu(xraw + 4, tempbuff);
								memcpy(xraw, dp, 2);
								xraw += 2;
								xraw += pShort(xraw, dl);
								xraw += dl;
							}
							break;
						}
						dp += dlen;

						if ((DWORD)raw - (DWORD)&req->dnsp + (DWORD)xraw - (DWORD)tempdata < sizeof(dns_packet))
						{
							req->dnsp.header.ancount = htons(htons(req->dnsp.header.ancount) + 1);
							//printf("%i\n", (DWORD)raw - (DWORD)&req->dnsp + (DWORD)xraw - (DWORD)tempdata);
							memcpy(raw, tempdata, ((DWORD)xraw - (DWORD)tempdata));
							raw += ((DWORD)xraw - (DWORD)tempdata);
						}
					}
					req->bytes = (DWORD)raw - (DWORD) & req->dnsp;
				}

				//cache the response
				if (req->query[0] && ntohs(req->dnsp.header.ancount) >= 1)
				{
					time_t expiry = getExpiry(&req->dnsp);
					time_t earliest = expiry;
					int j;
					for (j = 0; j < DNS_CACHE_MAX; j++)
						if (!strcasecmp(cfig->cache[j].query, cfig->queue[queueIndex].query) && cfig->cache[j].qtype == cfig->queue[queueIndex].qtype)
							break;

					//matching query not found, look for one with earliest expiry
					if (j == DNS_CACHE_MAX)
					{
						for (int k = DNS_CACHE_MAX - 1; k >= 0; k--)
						{
							if (cfig->cache[k].expiry < earliest)
							{
								j = k;
								earliest = cfig->cache[k].expiry;
							}
						}
					}

					//cache it
					if (j < DNS_CACHE_MAX)
					{
						cfig->cache[j].expiry = expiry;
						strcpy(cfig->cache[j].query, req->query);
						cfig->cache[j].qtype = req->qtype;
						cfig->cache[j].bytes = req->bytes;
						memcpy(&cfig->cache[j].dnsp, &req->dnsp, sizeof(dns_packet));
						//printf("\ncached %s=%i,ex=%u", req->query, j, expiry - time(NULL));
					}
				}
			}
		}
		else
			memcpy(&cfig->queue[queueIndex - 1], &cfig->queue[queueIndex], sizeof(data6));
	}

	if (!found)
		req->bytes = 0;

	req->dnsp.header.aa = 0;
	return req->bytes;
}

char* getResult(dns_packet *mess)
{
	tempbuff[0] = 0;
	char *raw = mess->data;
	WORD queueIndex;

	for (int i = 1; i <= ntohs(mess->header.qdcount); i++)
	{
		if ((BYTE)*raw > 63)
			raw += 2;
		else
			raw += strlen(raw) + 1;
		raw += 4;
	}

	for (int i = 1; i <= ntohs(mess->header.ancount); i++)
	{
		if ((BYTE)*raw > 63)
			raw += 2;
		else
			raw += strlen(raw) + 1;
		int type = fShort(raw);
		raw += 2; //type
		raw += 2; //class
		raw += 4; //ttl
		int dlen = fShort(raw);
		raw += 2; //datalength
		if (type == DNS_TYPE_A)
			return IP2String(*(DWORD*)raw);
		else if (type == DNS_TYPE_PTR)
		{
			fQu(tempbuff, mess, raw);
			return tempbuff;
		}
		else if (type == DNS_TYPE_CNAME)
			fQu(tempbuff, mess, raw);
		else if (type == DNS_TYPE_MX)
			fQu(tempbuff, mess, ++++raw);
		raw += dlen;
	}
	if (tempbuff[0])
		return tempbuff;
	else
		return NULL;
}

time_t getExpiry(dns_packet *dnsp)
{
	char *raw = dnsp->data;

	for (int i = 1; i <= ntohs(dnsp->header.qdcount); i++)
	{
		if ((BYTE)*raw > 63)
			raw += 2;
		else
			raw += (strlen(raw) + 1);
		raw += 4;
	}

	time_t expiry = ULONG_MAX;
	for (int i = 1; i <= ntohs(dnsp->header.ancount); i++)
	{
		if ((BYTE)*raw > 63)
			raw += 2;
		else
			raw += strlen(raw) + 1;
		raw += 4;

		if (expiry > fLong(raw))
			expiry = fLong(raw);

		raw += 4;
		raw += fShort(raw) + 2;
	}

	time_t ctime = time(NULL);

	if (ULONG_MAX - ctime < expiry)
		return LONG_MAX;
	else
		return (expiry + ctime);
}

BYTE *gvdata(BYTE *raw, data1 *req, data3 *op)
{
	while (*raw == 0)
		if (raw == req->dhcpp.bp_vend + DHCP_VENDORDATA_SIZE)
			return NULL;
		else
			raw++;

	if (*raw == DHCP_OPTION_END)
		return NULL;

	op->opt_code = *raw;
	raw++;
	op->size = *raw;
	raw++;
	memcpy(op->value, raw, op->size);
	raw += op->size;
	//printf("\n%u %u",op->opt_code, op->size);
	return raw;
}

WORD gdmess(data1 *req, data2 *cfig)
{
	//printf("\nHere");
	//int k;
	//getsockname(cfig->socket[0], (SOCKADDR*)&req->inSockAddr, &k);
	//printf("\nLocal1=%s", inet_ntoa(req->inSockAddr.sin_addr));

	memset(req, 0, sizeof(data1));

	socklen_t nLen = sizeof(req->sockAddr);
	req->bytes = recvfrom(cfig->socket[0],
	                      req->raw,
	                      sizeof(dhcp_packet),
	                      0,
	                      (LPSOCKADDR) & req->sockAddr,
	                      &nLen);

	if (req->bytes <= 0)
		return 0;

	if (!cfig->servers[0])
		glocal(cfig);

	if (!cfig->servers[0])
		return 0;

	data3 op;
	BYTE *raw = req->dhcpp.bp_vend;

	while (raw = gvdata(raw, req, &op))
	{
		switch (op.opt_code)
		{
		case DHCP_OPTION_PARAMREQLIST:
			memcpy(req->paramreqlist, op.value, op.size);
			break;

		case DHCP_OPTION_MESSAGETYPE:
			req->req_type = op.value[0];
			break;

		case DHCP_OPTION_SERVERID:
			req->server = op.longvalue;
			break;

		case DHCP_OPTION_IPADDRLEASE:
			req->lease = htonl(op.longvalue);
			break;

		case DHCP_OPTION_MAXDHCPMSGSIZE:
			req->messsize = htons(op.shortvalue);
			break;

		case DHCP_OPTION_REQUESTEDIPADDR:
			req->reqIP = op.longvalue;
			break;

		case DHCP_OPTION_HOSTNAME:
			if (op.size)
			{
				memcpy(req->hostname, op.value, op.size);
				req->hostname[op.size] = 0;
				char *dp = strchr(req->hostname, 46);
				if (dp != NULL)
					*dp = 0;
			}
			break;
		}
	}
	return req->req_type;
}

DWORD resad(data1 *req, data2 *cfig)
{
	int proposed_candidate = -1;
	int expired_candidate = -1;
	int i;
	BYTE empty[10];
	memset(empty, 0, sizeof(empty));
	time_t currentTime = time(NULL);

	if (!cfig->servers[0])
		return 0;

	int j = cfig->rangeEnd - cfig->rangeStart;

	for (i = 0; i <= j; i++)
	{
		if (!cfig->clients[i].server)
		{
			if (!memcmp(req->dhcpp.bp_chaddr, cfig->clients[i].chaddr, sizeof(empty)))
				break;
			else if ((cfig->clients[i].hostname[0] && !strcasecmp(req->hostname, cfig->clients[i].hostname)) || (proposed_candidate < 0 && !cfig->clients[i].static_host && !memcmp(cfig->clients[i].chaddr, empty, sizeof(empty))))
				proposed_candidate = i;
			else if (!cfig->clients[i].static_host && expired_candidate < 0 && memcmp(cfig->clients[i].chaddr, empty, sizeof(empty)) && cfig->clients[i].expiry < currentTime)
				expired_candidate = i;
		}
	}

	//printf("static_host=%i", i);

	if (i <= j)
		proposed_candidate = i;
	else if (proposed_candidate < 0 && expired_candidate >= 0)
		proposed_candidate = expired_candidate;
	else if (proposed_candidate < 0)
		return 0;

	if (!cfig->messsize[proposed_candidate])
		cfig->messsize[proposed_candidate] = sizeof(dhcp_packet);

	if (req->messsize)
		cfig->messsize[proposed_candidate] = req->messsize;
	else
		req->messsize = cfig->messsize[proposed_candidate];

	memcpy(cfig->clients[proposed_candidate].chaddr, req->dhcpp.bp_chaddr, sizeof(empty));
	cfig->clients[proposed_candidate].expiry = currentTime + 120;
	return htonl(cfig->rangeStart + proposed_candidate);
}

DWORD chad(DWORD ip, data1 *req, data2 *cfig)
{
	int j = getIndex(cfig, ip);

	if (j >= 0)
	{
		if (!memcmp(req->dhcpp.bp_chaddr, cfig->clients[j].chaddr, 8))
		{
			if (strlen(req->hostname) && !strlen(cfig->clients[j].hostname))
				strcpy(cfig->clients[j].hostname, req->hostname);
			else if (strlen(cfig->clients[j].hostname))
				strcpy(req->hostname, cfig->clients[j].hostname);

			return ip;
		}

		if (!cfig->messsize[j])
			cfig->messsize[j] = sizeof(dhcp_packet);

		if (req->messsize)
			cfig->messsize[j] = req->messsize;
		else
			req->messsize = cfig->messsize[j];

	}
	return 0;
}

DWORD alad(data1 *req, data2 *cfig)
{
	int j = getIndex(cfig, req->dhcpp.bp_yiaddr);

	if (j >= 0)
	{
		if (ULONG_MAX - time(NULL) > req->lease)
			cfig->clients[j].expiry = time(NULL) + req->lease;
		else
			cfig->clients[j].expiry = ULONG_MAX;

		FILE *f = fopen(leaFile, "r+");
		if (f)
		{
			fseek(f, 4 + j*sizeof(data8), SEEK_SET);
			fwrite(&cfig->clients[j], sizeof(data8), 1, f);
			fclose(f);
		}
		return req->dhcpp.bp_yiaddr;
	}
	return 0;
}

DWORD sdmess(data1 *req, data2 *cfig)
{
	if (req->req_type == DHCP_MESS_DECLINE)
	{
		req->dhcpp.bp_yiaddr = resad(req, cfig);
		int j = getIndex(cfig, req->dhcpp.bp_yiaddr);
		if (j >= 0)
			cfig->clients[j].static_host = 1;
		return 0;
	}
	else if (req->req_type == DHCP_MESS_INFORM)
		return 0;
	else if (req->req_type == DHCP_MESS_DISCOVER && strcasecmp(req->hostname, cfig->servername))
	{
		req->resp_type = DHCP_MESS_OFFER;
		req->dhcpp.bp_yiaddr = resad(req, cfig);
		if (!req->dhcpp.bp_yiaddr)
			return 0;
	}
	else if (req->req_type == DHCP_MESS_REQUEST)
	{
		if (req->server)
		{
			if (req->server == cfig->servers[0])
			{
				if (req->reqIP && chad(req->reqIP, req, cfig))
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.bp_yiaddr = req->reqIP;
				}
				else if (req->dhcpp.bp_ciaddr && chad(req->dhcpp.bp_ciaddr, req, cfig))
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.bp_yiaddr = req->dhcpp.bp_ciaddr;
				}
				else
				{
					req->resp_type = DHCP_MESS_DECLINE;
					req->dhcpp.bp_yiaddr = 0;
				}
			}
			else
				return 0;
		}
		else if (req->dhcpp.bp_ciaddr)
		{
			if (chad(req->dhcpp.bp_ciaddr, req, cfig))
			{
				req->resp_type = DHCP_MESS_ACK;
				req->dhcpp.bp_yiaddr = req->dhcpp.bp_ciaddr;
			}
			else
			{
				//printf("%u",chad(req->dhcpp.bp_ciaddr, req, cfig));
				req->resp_type = DHCP_MESS_DECLINE;
				req->dhcpp.bp_yiaddr = 0;
			}
		}
		else if (req->reqIP)
		{
			if (chad(req->reqIP, req, cfig))
			{
				req->resp_type = DHCP_MESS_ACK;
				req->dhcpp.bp_yiaddr = req->reqIP;
			}
			else
			{
				req->resp_type = DHCP_MESS_DECLINE;
				req->dhcpp.bp_yiaddr = 0;
			}
		}
		else
			return 0;
	}
	else
		return 0;

	int j = (DWORD)addOp(req, cfig) - (DWORD) & req->dhcpp;



	req->sockAddr.sin_family = AF_INET;
	req->sockAddr.sin_port = htons(IPPORT_DHCPC);

	if (req->dhcpp.bp_ciaddr)
		req->sockAddr.sin_addr.s_addr = req->dhcpp.bp_ciaddr;
	else
		req->sockAddr.sin_addr.s_addr = INADDR_BROADCAST;

	errno = 0;
	req->bytes = sendto(cfig->socket[0],
	                    req->raw,
	                    j,
	                    0,
	                    (sockaddr*) & req->sockAddr,
	                    sizeof(req->sockAddr));

	if (req->resp_type == DHCP_MESS_ACK && req->bytes > 0 && req->dhcpp.bp_yiaddr)
		return alad(req, cfig);

	return 0;
}

BYTE *addOp(data1 *req, data2 *cfig)
{
	if (!req->messsize)
		req->messsize = sizeof(dhcp_packet);

	data3 op;
	int i;

	memset(req->dhcpp.bp_vend, 0, DHCP_VENDORDATA_SIZE);
	BYTE *vp = req->dhcpp.bp_vend;

	op.opt_code = DHCP_OPTION_MESSAGETYPE;
	op.size = 1;
	op.value[0] = req->resp_type;
	vp = pvdata(vp, req, &op);

	if (req->resp_type != DHCP_MESS_DECLINE)
	{
		if (*cfig->globalOptions)
		{
			for (int u = 0; u < 128 && req->paramreqlist[u]; u++)
				if (67 == req->paramreqlist[u])
				{
					strcpy((char*)req->dhcpp.bp_file, cfig->boot_file);
					req->dhcpp.bp_siaddr = cfig->boot_server;
				}
		}
		else
		{
			strcpy((char*)req->dhcpp.bp_file, cfig->boot_file);
			req->dhcpp.bp_siaddr = cfig->boot_server;
		}

		op.opt_code = DHCP_OPTION_NETMASK;
		op.size = 4;
		op.longvalue = cfig->subnetmask;
		vp = pvdata(vp, req, &op);

		op.opt_code = DHCP_OPTION_SERVERID;
		op.size = 4;
		if (cfig->serverip)
			op.longvalue = cfig->serverip;
		else
			op.longvalue = cfig->servers[0];

		vp = pvdata(vp, req, &op);

		op.opt_code = DHCP_OPTION_DOMAINNAME;
		op.size = strlen(cfig->domainname);
		memcpy(op.value, cfig->domainname, op.size);
		vp = pvdata(vp, req, &op);

		if (strlen(req->hostname))
		{
			op.opt_code = DHCP_OPTION_HOSTNAME;
			op.size = strlen(req->hostname);
			memcpy(op.value, req->hostname, op.size);
			vp = pvdata(vp, req, &op);
		}

		for (i = 0; i < 5; i++)
			if (!cfig->routers[i])
				break;

		if (i > 0)
		{
			op.opt_code = DHCP_OPTION_ROUTER;
			op.size = i * 4;
			memcpy(op.value, cfig->routers, op.size);
			vp = pvdata(vp, req, &op);
		}

		if (dnsService)
		{
			op.opt_code = DHCP_OPTION_DNS;
			if (cfig->serverip)
			{
				op.longvalue = cfig->serverip;
				op.size = 4;
				vp = pvdata(vp, req, &op);
			}
			else
			{
				for (i = 0; i < 5; i++)
					if (!cfig->servers[i])
						break;
				if (i > 0)
				{
					op.size = i * 4;
					memcpy(op.value, cfig->servers, op.size);
					vp = pvdata(vp, req, &op);
				}
			}
		}
		else
		{
			for (i = 0; i < 5; i++)
				if (!cfig->dns[i])
					break;
			if (i > 0)
			{
				op.opt_code = DHCP_OPTION_DNS;
				op.size = i * 4;
				memcpy(op.value, cfig->dns, op.size);
				vp = pvdata(vp, req, &op);
			}
		}

		if (req->lease == 0 || req->lease > cfig->lease)
			req->lease = cfig->lease;

		op.opt_code = DHCP_OPTION_IPADDRLEASE;
		op.size = 4;
		op.longvalue = htonl(req->lease);
		vp = pvdata(vp, req, &op);

		strcpy(req->dhcpp.bp_sname, cfig->servername_fqn);

		BYTE *opPointer = cfig->globalOptions ;
		opPointer++;
		while (*opPointer && *opPointer < UCHAR_MAX)
		{
			BYTE opsize = *(opPointer + 1) + 2;
			if (((DWORD)vp) - ((DWORD)&req->dhcpp) + opsize < req->messsize)
			{
				int addThisOption = 1;
				if (*cfig->globalOptions)
				{
					addThisOption = 0;
					for (int u = 0; u < 128 && req->paramreqlist[u]; u++)
						if (*opPointer == req->paramreqlist[u])
						{
							addThisOption = 1;
							break;
						}
				}
				if (addThisOption)
				{
					memcpy(vp, opPointer, opsize);
					vp += opsize;
				}
				opPointer += opsize;
			}
			else
				break;
		}

		opPointer = cfig->clientOptions[getIndex(cfig, req->dhcpp.bp_yiaddr)];
		//printf("clientbuffer%u=%u", getIndex(cfig, req->dhcpp.bp_yiaddr), opPointer);
		opPointer++;
		while (*opPointer && *opPointer < UCHAR_MAX)
		{
			BYTE opsize = *(opPointer + 1) + 2;
			if (((DWORD)vp) - ((DWORD)&req->dhcpp) + opsize < req->messsize)
			{
				memcpy(vp, opPointer, opsize);
				vp += opsize;
				opPointer += opsize;
			}
			else
				break;
		}
	}

	*vp = DHCP_OPTION_END;
	req->dhcpp.bp_op = DHCP_REPLY;

	//printf("%i\n", ((DWORD)vp) - ((DWORD)&req->dhcpp));

	return vp;
}

BYTE *pvdata(BYTE *vp, data1 *req, data3 *op)
{
	BYTE opsize = op->size + 2;
	if (req->messsize && ((DWORD)vp) - ((DWORD)&req->dhcpp) + opsize < req->messsize)
	{
		*vp = op->opt_code;
		vp++;
		*vp = op->size;
		vp++;
		memcpy(vp, op->value, op->size);
		vp += op->size;
	}
	return vp;
}

void indata(data2 *cfig)
{
	memset(cfig, 0, sizeof(data2));

	cfig->rangeStart = htonl(my_inet_addr("192.168.0.1"));
	cfig->rangeEnd = cfig->rangeStart + DHCP_MAX_CLIENTS - 1;
	cfig->lease = 36000;

	char iniStr[8192];

	if (getSection("IP-RANGE", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		if (strlen(iniStrPtr))
		{
			DWORD rs = htonl(my_inet_addr(iniStrPtr));
			DWORD re = htonl(my_inet_addr(cleanstr(iniStrPtr, true)));

			if (rs && rs != INADDR_NONE && re && re != INADDR_NONE && (rs % 256) != 0 && (re % 256 != UCHAR_MAX) && (rs / 256) == (re / 256) && rs <= re)
			{
				cfig->rangeStart = rs;
				cfig->rangeEnd = re;
			}
			else if (verbatim)
				printf("Warning: Invalid DHCP range in ini file, ignored\n");
		}
	}

	cfig->network = getNetwork(htonl(cfig->rangeStart));

	if (getSection("SERVICES", iniStr, sizeof(iniStr), iniFile))
	{
		dhcpService = false;
		dnsService = false;
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i < 2 && strlen(iniStrPtr); i++, iniStrPtr = cleanstr(iniStrPtr, true))
			if (!strcasecmp(iniStrPtr, "DNS"))
				dnsService = true;
			else if (!strcasecmp(iniStrPtr, "DHCP"))
				dhcpService = true;
		if (!dhcpService && !dnsService)
		{
			dhcpService = true;
			dnsService = true;
		}
	}

	if (dhcpService)
	{
		FILE *f = fopen(leaFile, "r");
		if (f)
		{
			DWORD rangeStart = 0;
			fread(&rangeStart, 4, 1, f);
			if (rangeStart == cfig->rangeStart)
				fread(cfig->clients, sizeof(data8), DHCP_MAX_CLIENTS, f);
			fclose(f);
		}

		f = fopen(leaFile, "w");
		if (f)
		{
			fwrite(&cfig->rangeStart, 4, 1, f);
			fwrite(cfig->clients, sizeof(data8), DHCP_MAX_CLIENTS, f);
			fclose(f);
		}

		if (getSection("DHCP-OPTIONS", iniStr, sizeof(iniStr), iniFile))
		{
			loadOptions(cfig, cfig->globalOptions, sizeof(cfig->globalOptions), iniStr, "DHCP OPTIONS", -1);
		}

		for (DWORD client = cfig->rangeStart; client <= cfig->rangeEnd; client++)
			if (getSection(IP2String(htonl(client)), iniStr, sizeof(iniStr), iniFile))
				loadOptions(cfig, cfig->clientOptions[client - cfig->rangeStart], sizeof(cfig->clientOptions[0]), iniStr, tempbuff, client - cfig->rangeStart);
	}

	if (getSection("DOMAIN-NAME", iniStr, sizeof(iniStr), iniFile))
		strcpy(cfig->domainname, cleanstr(iniStr, false));

	if (getSection("LISTEN-ON", iniStr, sizeof(iniStr), iniFile))
		cfig->serverip = my_inet_addr(cleanstr(iniStr, false));

	if (getSection("ROUTERS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i < 5, strlen(iniStrPtr); i++, iniStrPtr = cleanstr(iniStrPtr, true))
			addEntry(cfig, cfig->routers, my_inet_addr(iniStrPtr));
	}
	cfig->routerSpecified = (cfig->routers[0] > 0);

	if (getSection("LEASE-SECONDS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		if (strlen(iniStrPtr))
			cfig->lease = atoi(iniStrPtr);
		if (!cfig->lease)
			cfig->lease = ULONG_MAX;
	}

	glocal(cfig);
	getdnserv(cfig);

	sprintf(cfig->servername_fqn, "%s.%s", cfig->servername, cfig->domainname);

	if (dhcpService)
	{
		cfig->socket[0] = socket(AF_INET,
						SOCK_DGRAM,
						IPPROTO_UDP);

		if (cfig->socket[0] == INVALID_SOCKET)
			return ;

		cfig->sockAddr[0].sin_family = AF_INET;
		cfig->sockAddr[0].sin_addr.s_addr = INADDR_ANY;
		cfig->sockAddr[0].sin_port = htons(IPPORT_DHCPS);

		int bOptVal = true;
		int bOptLen = sizeof(bOptVal);
		//setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *) &n, sizeof(n);
		setsockopt(cfig->socket[0], SOL_SOCKET, SO_REUSEADDR, (char*)&bOptVal, bOptLen);
		int bOptVal1 = true;
		int bOptLen1 = sizeof(bOptVal1);
		setsockopt(cfig->socket[0], SOL_SOCKET, SO_BROADCAST, (char*)&bOptVal1, bOptLen1);

		int nRet = bind(cfig->socket[0],
				(LPSOCKADDR) & cfig->sockAddr[0],
				sizeof(struct sockaddr_in)
				);

		if (nRet == SOCKET_ERROR)
		{
			close(cfig->socket[0]);
			if (verbatim)
				printf("Error: Port 67 already in use\n");
			else
				syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Port 67 already in use");
			scanf(tempbuff);
			exit(1);
		}

	}

	if (dnsService)
	{
		cfig->socket[1] = socket(AF_INET,
						SOCK_DGRAM,
						IPPROTO_UDP);

		if (cfig->socket[1] == INVALID_SOCKET)
			return ;

		cfig->sockAddr[1].sin_family = AF_INET;
		cfig->sockAddr[1].sin_addr.s_addr = cfig->serverip;
		cfig->sockAddr[1].sin_port = htons(IPPORT_DNS);

		int nRet = bind(cfig->socket[1],
				(LPSOCKADDR) & cfig->sockAddr[1],
				sizeof(struct sockaddr_in)
				);
		if (nRet == SOCKET_ERROR)
		{
			if (cfig->socket[0])
				close(cfig->socket[0]);
			close(cfig->socket[1]);
			if (verbatim)
				printf("Error: Port 53 already in use\n");
			else
				syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Port 53 already in use");
			exit(1);
		}

		cfig->socket[2] = socket(AF_INET,
						SOCK_DGRAM,
						IPPROTO_UDP);

		if (cfig->socket[2] == INVALID_SOCKET)
		{
			if (cfig->socket[0])
				close(cfig->socket[0]);
			if (cfig->socket[1])
				close(cfig->socket[1]);
			exit(1);
		}
	}

	if (getSection("STATIC-HOSTS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		while (strlen(iniStrPtr))
		{
			char name[256];
			strncpy(name, iniStrPtr, UCHAR_MAX);
			char *value = strchr(name, 61);
			if (value != NULL)
			{
				*value = 0;
				value++;
				DWORD inetAddr = my_inet_addr(value);
				int i = getIndex(cfig, inetAddr);
				if (i >= 0)
				{
					strcpy(cfig->clients[i].hostname, name);
					cfig->clients[i].static_host = 1;
				}
			}
			iniStrPtr = cleanstr(iniStrPtr, true);
		}
	}

	if (getSection("ALIASES", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		while (strlen(iniStrPtr) && cfig->cnameCount < DNS_MAX_ALIAS)
		{
			char name[512];
			strncpy(name, iniStrPtr, 511);
			char *value = strchr(name, 61);
			if (value != NULL)
			{
				*value = 0;
				value++;
				if (strlen(value) && strlen(name))
				{
					strncpy(cfig->cnames[cfig->cnameCount].alias, name, UCHAR_MAX);
					strncpy(cfig->cnames[cfig->cnameCount].cname, value, UCHAR_MAX);
					cfig->cnameCount++;
				}
			}
			iniStrPtr = cleanstr(iniStrPtr, true);
		}
	}

	if (getSection("MAIL-SERVERS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		while (strlen(iniStrPtr) && cfig->mxCount < 10)
		{
			char name[512];
			strncpy(name, iniStrPtr, 511);
			char *value = strchr(name, '=');
			if (value != NULL)
			{
				*value = 0;
				value++;
				if (strlen(value) && strlen(name))
				{
					cfig->mxServers[cfig->mxCount].pref = atoi(value);
					if (!strchr(name, '.'))
					{
						strcat(name, ".");
						strcat(name, cfig->domainname);
					}
					strcpy(cfig->mxServers[cfig->mxCount].hostname, name);
					cfig->mxCount++;
				}
			}
			iniStrPtr = cleanstr(iniStrPtr, true);
		}
	}

	if (getSection("WEB-SERVER", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		strncpy(cfig->webServer, iniStrPtr, UCHAR_MAX);
	}

}

void glocal(data2 *cfig)
{
	gethostname(cfig->servername, sizeof(cfig->servername));
	if (!strlen(cfig->domainname))
		getdomainname(cfig->domainname, sizeof(cfig->domainname));
	if (!strncmp(cfig->domainname, "(none)", 6) || !strlen(cfig->domainname))
		strcpy(cfig->domainname, "workgroup");
	char buff[512];
	FILE *f = popen("/sbin/ifconfig", "r");
	bool eth = false;
	char *valueStart = NULL;
	char *valueEnd = NULL;
	char value[256];
	while (f && fgets(buff, sizeof(buff), f))
	{
		if (strstr(buff, "eth") == buff)
			eth = true;
		else if (strstr(buff, "  ") != buff)
			eth = false;

		if (eth && (valueStart = strstr(buff, "inet addr")))
		{
			valueStart += 10;
			valueEnd = strstr(valueStart, " ");
			if (!valueEnd)
				valueEnd = strstr(valueStart, "\n");
			if (valueEnd)
			{
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				DWORD addr = my_inet_addr(value);
				if (getNetwork(addr) == cfig->network)
					addEntry(cfig, cfig->servers, addr);
			}
		}
		if (eth && (valueStart = strstr(buff, "Mask")))
		{
			valueStart += 5;
			valueEnd = strstr(valueStart, " ");
			if (!valueEnd)
				valueEnd = strstr(valueStart, "\n");
			if (valueEnd)
			{
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				cfig->subnetmask = my_inet_addr(value);
			}
		}
	}
	if (f)
		pclose(f);

	if (!cfig->routers[0])
	{
		f = popen("/sbin/route", "r");
		while (f && fgets(buff, sizeof(buff), f))
		{
			if (strstr(buff, "default") == buff || strstr(buff, "0.0.0.0") == buff)
			{
				valueStart = buff + 16;
				valueEnd = valueStart + 16;
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				int addr = my_inet_addr(value);
				if (!addr)
				{
					char *dot = strchr(value, 46);
					if (dot)
						*dot = 0;
					hostent *ent = gethostbyname(value);
					if (ent)
						addr = *(DWORD*)ent->h_addr_list[0];
				}
				if (getNetwork(addr) == cfig->network)
					addEntry(cfig, cfig->routers, addr);
			}
		}
		if (f)
			pclose(f);
	}

	for (int i = 0; i < 5; i++)
		if (cfig->servers[i] == cfig->serverip)
			break;
		else if (i == 4)
		{
			if (verbatim)
				printf("Warning: Interface %s not found, ignored\n", IP2String(cfig->serverip));
			else
			{
				char tempbuff1[256];
				sprintf(tempbuff1, "Interface %s not found, ignored", IP2String(cfig->serverip));
				syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_NOTICE), tempbuff1);
			}
			cfig->serverip = INADDR_ANY;
		}
}

void getdnserv(data2 *cfig)
{
	char iniStr[4096];

	if (getSection("DNS-SERVERS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i < 5 && strlen(iniStrPtr); i++, iniStrPtr = cleanstr(iniStrPtr, true))
		{
			DWORD addr = my_inet_addr(iniStrPtr);
			if (addr)
				addEntry(cfig, cfig->dns, addr);
		}
	}

	if (!cfig->dns[0])
	{
		FILE *f = fopen("/etc/resolv.conf", "r");
		char buff[256];
		char *pin;
		DWORD addr;
		while (f && fgets(buff, 128, f))
		{
			if (pin = strstr(buff, "nameserver"))
			{
				pin += 11;
				DWORD addr = my_inet_addr(pin);
				for (int i = 0;i < 5;i++)
					if (cfig->servers[i] == addr)
						break;
					else if (i == 4)
						addEntry(cfig, cfig->dns, addr);
			}
		}
		if (f)
			fclose(f);
	}
}

char* cleanstr(char* buff, BOOL next)
{
	if (strlen(buff) && next)
		buff += strlen(buff) + 1;
	while (strlen(buff))
		if (*buff >= 48 && *buff <= 57 || *buff >= 65 && *buff <= 90 || *buff >= 97 && *buff <= 122)
			break;
		else
			buff += strlen(buff) + 1;
	return buff;
}

char* IP2String(DWORD ip)
{
	in_addr inaddr;
	inaddr.s_addr = ip;
	sprintf(tempbuff, "%s", inet_ntoa(inaddr));
	return tempbuff;
}

BOOL getSection(char *sectionName, char *buffer, int sizeofbuffer, char *fileName)
{
	char section[256];
	sprintf(section, "[%s]", sectionName);
	//strupr(section);
	FILE *f = fopen(fileName, "r");
	char buff[256];
	char *temp = buffer;
	*temp = 0;
	BOOL found = false;
	while (f && fgets(buff, 255, f))
	{
		//strupr(buff);
		if (strstr(buff, section) == buff)
		{
			found = true;
			while (fgets(buff, 255, f))
			{
				if (strstr(buff, "[") == buff)
					break;
				sprintf(temp, "%s", buff);
				temp += strlen(buff);
				while (*temp <= 32)
					temp--;
				temp++;
				*temp = 0;
				temp++;
			}
			*temp = 0;
		}
	}
	if (f)
		fclose(f);
	return found;
}

int getIndex(data2 *cfig, DWORD ip)
{
	DWORD ipTrans = htonl(ip);
	if (ipTrans >= cfig->rangeStart && ipTrans <= cfig->rangeEnd)
		return (ipTrans - cfig->rangeStart);
	else
		return -1;
}

DWORD getNetwork(DWORD ip)
{
	union {
		DWORD network;
		BYTE x[4];
	} data;

	data.network = ip;
	data.x[3] = 0;
	if (data.x[0] < 192)
		data.x[2] = 0;
	if (data.x[0] < 128)
		data.x[1] = 0;

	return data.network;
}

void addEntry(data2 *cfig, DWORD *array, DWORD entry)
{
	for (int i = 0; i < 5; i++)
		if (array[i] == entry)
			return ;
		else if (!array[i])
		{
			array[i] = entry;
			int j = getIndex(cfig, entry);
			if (j >= 0)
				cfig->clients[j].server = true;
			return ;
		}
}

DWORD my_inet_addr(char* str)
{
	if (str == NULL)
		return INADDR_ANY;
	DWORD x = inet_addr(str);
	if (x == INADDR_NONE)
		return INADDR_ANY;
	else
		return x;
}

void loadOptions(data2 *cfig, BYTE *buff, WORD buffsize, char *iniStr, char *section, int clientIndex)
{
	//printf("clientbuffer%u=%u", clientIndex, buff);
	BYTE *lastOptionIndex = NULL;
	BYTE *vp = buff;
	vp++;

	char *iniStrPtr = cleanstr(iniStr, false);
	while (strlen(iniStrPtr))
	{
		//printf("%i=%s\n", buffsize, iniStrPtr);
		char name[511];
		strncpy(name, iniStrPtr, 511);
		char *value = strchr(name, '=');
		if (value != NULL)
		{
			*value = 0;
			value++;
			if (strlen(value) && strlen(name))
			{
				if (atoi(name) && atoi(name) < UCHAR_MAX)
				{
					BYTE option[256];
					if (char* errorPos = getHexValue(option, value))
					{
						if (verbatim)
							printf("Warning section [%s] option %s position %u, Invalid char %c, option ignored\n", section, name, (DWORD)errorPos - (DWORD)value + 1, *(errorPos));
					}
					else if (buffsize > (option[0] + 2))
					{
						*vp = atoi(name);
						vp++;
						*vp = option[0];
						vp++;
						memcpy(vp, option + 1, option[0]);
						vp += option[0];
						buffsize -= (option[0] + 2);
					}
					else if (verbatim)
						printf("Warning section [%s] option %s no more space for options\n", section, name);
				}
				else
				{
					int i;
					for (i = 0; i < sizeof(op_index); i++)
						if (!strcasecmp(name, op_name[i]))
							break;
					if (i >= sizeof(op_index))
					{
						if (verbatim)
							printf("Warning section [%s] Invalid option %s, ignored\n", name);
					}
					else
					{
						if (op_size[i] < UCHAR_MAX && op_size[i] != 0 && (*value < '0' || *value > '9'))
						{
							if (verbatim)
								printf("Warning section [%s] option %s Numeric Value Required, option ignored\n", section, name);
						}
						else if (op_size[i] == 0)
						{
							int j = 0;
							char *temp = value;
							while (strlen(temp))
							{
								temp = strchr(temp, '.');
								if (temp)
								{
									j++;
									temp++;
								}
								else
									break;
							}
							if (j == 3 && (my_inet_addr(value) != INADDR_NONE || !strcmp(value, "UCHAR_MAX.UCHAR_MAX.UCHAR_MAX.UCHAR_MAX")))
							{
								DWORD inetAddr = my_inet_addr(value);
								if (!strcasecmp(op_name[i], "Next_Server"))
									cfig->boot_server = inetAddr;
								else if (buffsize > 6)
								{
									if (lastOptionIndex && *lastOptionIndex == op_index[i])
									{
										*(lastOptionIndex + 1) += 4;
									}
									else
									{
										lastOptionIndex = vp;
										*vp = op_index[i];
										vp++;
										*vp = 4;
										vp++;
										buffsize -= 2;
									}
									memcpy(vp, &inetAddr, 4);
									vp += 4;
									buffsize -= 4;
								}
								else if (verbatim)
									printf("Warning section [%s] option %s no more space for options\n", section, name);
							}
							else
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be 4 octates, option ignored\n", section, name);
							}
						}
						else if (op_size[i] == 4)
						{
							if (buffsize > 4)
							{
								lastOptionIndex = 0;
								long j = htonl(atol(value));
								*vp = op_index[i];
								vp++;
								*vp = 4;
								vp++;
								memcpy(vp, &j, 4);
								vp += 4;
								buffsize -= 6;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (op_size[i] == 2)
						{
							long j = htons(atol(value));
							if (j > USHRT_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be between 0 & %u, option ignored\n", section, name, USHRT_MAX);
							}
							else if (buffsize > 4)
							{
								if (lastOptionIndex && *lastOptionIndex == op_index[i])
								{
									*(lastOptionIndex + 1) += 2;
								}
								else
								{
									lastOptionIndex = vp;
									*vp = op_index[i];
									vp++;
									*vp = 2;
									vp++;
									buffsize -= 2;
								}
								memcpy(vp, &j, 2);
								vp += 2;
								buffsize -= 2;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (op_size[i] == 1)
						{
							lastOptionIndex = NULL;
							long j = atol(value);
							if (!strcasecmp(op_name[i], "Send_Only_Requested_Options"))
							{
								if (atoi(value) > 1)
								{
									if (verbatim)
										printf("Warning section [%s] option %s Value should be between 0 & 1, option ignored\n", section, name);
								}
								else
									*buff = atoi(value);
							}
							else if (j > UCHAR_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be between 0 & %u, option ignored\n", section, name, UCHAR_MAX);
							}
							else if (buffsize > 3)
							{
								*vp = op_index[i];
								vp++;
								*vp = 1;
								vp++;
								memcpy(vp, &j, 1);
								vp++;
								buffsize -= 3;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (op_index[i] == DHCP_OPTION_BOOTFILE && strlen(value) < 128)
						{
							lastOptionIndex = NULL;
							strcpy(cfig->boot_file, value);
						}
						else if (!strcasecmp(op_name[i], "Hardware_Addr") && clientIndex >= 0 )
						{
							BYTE haddr[32];
							memset(haddr, 0, sizeof(haddr));
							if (!getHexValue(haddr, value))
							{
								for (int z = 0;	z < DHCP_MAX_CLIENTS; z++)
									if (!memcmp(cfig->clients[z].chaddr, haddr + 1, sizeof(cfig->clients[0].chaddr)))
										memset(cfig->clients[z].chaddr, 0, sizeof(cfig->clients[0].chaddr));
								memcpy(cfig->clients[clientIndex].chaddr, haddr + 1, sizeof(cfig->clients[0].chaddr));
							}
							else if (verbatim)
								printf("Warning section [%s] option %s invalid value %s, option ignored\n", section, name, value);
						}
						else if (op_index[i] == DHCP_OPTION_HOSTNAME && strlen(value) < 128)
						{
							lastOptionIndex = NULL;
							strcpy(cfig->clients[clientIndex].hostname, value);
						}
						else
						{
							lastOptionIndex = NULL;
							if (strlen(value) >= UCHAR_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s value too big, option ignored\n", section, name);
							}
							else if (buffsize > strlen(value))
							{
								*vp = op_index[i];
								vp++;
								*vp = strlen(value);
								vp++;
								memcpy(vp, value, strlen(value));
								vp += (strlen(value));
								buffsize -= (strlen(value) + 2);
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
					}
				}
			}
			else
			{
				if (verbatim)
					printf("Warning section [%s] option %s missing value, option ignored\n", section, name);
			}
		}
		else
		{
			if (verbatim)
				printf("Warning section [%s] option %s missing = sign, option ignored\n", section, name);
		}
		iniStrPtr = cleanstr(iniStrPtr, true);
		//printf("\n%i\n",*vp);
	}
	*vp = DHCP_OPTION_END;
}

char *getHexValue(BYTE *target, char *source)
{
	BYTE *targetBegin = target;

	target++;
	while (*source)
	{
		if (*source >= '0' && *source <= '9')
		{
			(*target) = (*source) - '0';
		}
		else if (*source >= 'a' && *source <= 'f')
		{
			(*target) = (*source) - 'a' + 10;
		}
		else if (*source >= 'A' && *source <= 'F')
		{
			(*target) = (*source) - 'A' + 10;
		}
		else
		{
			return source;
		}

		source++;

		if (*source >= '0' && *source <= '9')
		{
			(*target) *= 16;
			(*target) += (*source) - '0';
			target++;
		}
		else if (*source >= 'a' && *source <= 'f')
		{
			(*target) *= 16;
			(*target) += (*source) - 'a' + 10;
			target++;
		}
		else if (*source >= 'A' && *source <= 'F')
		{
			(*target) *= 16;
			(*target) += (*source) - 'A' + 10;
			target++;
		}
		else if ((*source) == ':' || (*source) == '-')
		{
			source++;
			target++;
			continue;
		}
		else if (*source)
		{
			return source;
		}
		else
		{
			target++;
			break;
		}

		source ++;

		if (*source != ':' && *source != '-')
		{
			if (*source)
			{
				return source;
			}
			else
			{
				break;
			}
		}
		source++;
	}
	*targetBegin = (DWORD)target - (DWORD)targetBegin - 1;
	return NULL;
}
